/* copyright.h */
/*
 *  Copyright Notice for PennMUSH 1.50
 *
 * TinyMUSH 1.x Source code
 * Based on TinyMUD code
 *
 * -*-C-*-
 * 
 * Copyright (c) 1989, 1990 by David Applegate, James Aspnes, 
 *                             Timothy Freeman, and Bennet Yee.
 * 
 * This material was developed by the above-mentioned authors. Permission to
 * copy this software, to redistribute it, and to use it for any purpose is
 * granted, subject to the following restrictions and understandings.
 * 
 * 1. Any copy made of this software must include this copyright notice 
 * in full.
 * 
 * 2. Users of this software agree to make their best efforts (a) to return to
 * the above-mentioned authors any improvements or extensions that they make,
 * so that these may be included in future releases; and (b) to inform the
 * authors of noteworthy uses of this software.
 * 
 * 3. All materials developed as a consequence of the use of this software 
 * shall duly acknowledge such use, in accordance with the usual standards of
 * acknowledging credit in academic research.
 * 
 * 4. The authors have made no warrantee or representation that the operation 
 * of this software will be error-free, and the authors are under no obligation
 * to provide any services, by way of maintenance, update, or otherwise.
 * 
 * 5. In conjunction with products arising from the use of this material, there
 * shall be no use of the names of the authors, of Carnegie-Mellon
 * University, nor of any adaptation thereof in any advertising, promotional,
 * or sales literature without prior written consent from the authors and
 * Carnegie-Mellon University in each case.
 * 
 * The original TinyMUD code has been heavily modified by Lawrence Foard. This
 * code is presently in a constant state of change and is known to contain
 * some unresolved bugs. It is given out on an as is basis. I ask only that I
 * be given credit for additional features I have created ( @destroy,@asucc
 * etc).
 * 
 * Credits (for borrowed ideas &| code): Robert Hood (virus): Modified the
 * interface.c code to support alots of users. Lachesis: Introduced the idea
 * of property lists to TinyMUCK Many others: Many features borrowed from
 * other muds.
 *
 *---
 *
 * This code is heavily based on the micromush code which in turn was based on
 * the mush code.  I have modified it quite a bit since then as detailed in
 * the file CHANGES.   -- Moonchilde (JT Traub, jt1o@andrew.cmu.edu)
 *
 *---
 *
 * This code is based on the Pern code which Moonchilde stopped supporting
 * when PernMUSH itself went to 2.0. The file CHANGES-1 now details
 * Moonchilde's extensive modifications (PernMUSH 1.02 through 1.15).
 * The file CHANGES-2 now contains my modifications (PernMUSH 1.16, and
 * PennMUSH 1.17 to 1.19). PennMUSH 1.50.p1 changes and beyond are
 * in CHANGES-3. 
 *
 * This source code may not be copied, in part or in full, without
 * acknowledgement of the authors. The same is true of the help text.
 *
 *         -- Amberyl (Lydia Leong, lwl@eniac.seas.upenn.edu)
 *
 * Additional credits:
 *
 * Moonchilde and Ambar: Answered my occasional screams for help.
 *   Ambar also did a lot of bugfixing in versions 1.14 and 1.15.
 * Delta@Twilight: Added much of the HP-UX compatibility.
 * Jim Miller: Provided pointers to a few problems in the code
     which had been overlooked for quite some time.
 * Annalyn@PernMUSH, Javelin@Belgariad, Talek@Belgariad, and lots of others:
 *   Contributed lots and lots of good ideas.
 * TinyMUSH 2.0 and the mushhacks: Answered lots of questions,
 *   contributed many ideas, and in general acted extremely helpful.
 *   A small portion of this code is taken from TinyMUSH 2.0.
 *   Such sections are clearly marked with "taken from the 2.0 code".
 *   The parser is mostly from 2.0  (the end section of eval.c), with
 *   some modifications; this author is grateful for the use of the
 *   TinyMUSH 2.0 parser code.
 * Rosse@PernMUSH: Answered lots of probably inane coding questions,
 *   and providing help in tracking down various problems.
 * Henrik, Kheldar, and other Belgariad players: Did a fair amount
 *   of testing on the new parser and were very patient in figuring
 *   out test cases that went wrong and waiting for bugs to be fixed.
 * Zakath, Garion, Varana, and Geran of the the Belgariad, Tiercel@Pern,
 *   and the rest of the Penn MUSHers: Kept me sane and dragged me away
 *   from my terminal when necessary.  :) 
 * The rest of the Belgariad wiz team: Durnik for sanity checks, and
 *   everyone else for putting up with the occasional weird code bug.
 *
 * TinyMUSH 2.0 is Copyright (c) 1991 Joseph Traub and Glenn Crocker.
 * If you use of sections of this code which contain source code from 2.0,
 * you must retain this copyright notice.
 *
 * THIS CODE MAY NOT BE USED COMMERCIALLY.
 *
 */
